"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var react_1 = __importDefault(require("react"));
var spin_1 = require("../spin");
var utils_1 = require("../utils");
exports.Button = function (props) {
    var type = props.type, disabled = props.disabled, mini = props.mini, className = props.className, loading = props.loading, children = props.children, otherProps = __rest(props, ["type", "disabled", "mini", "className", "loading", "children"]);
    var css = classnames_1.default('x-button', {
        'x-button--disabled': disabled || loading,
        'x-button--mini': mini
    }, 'x-button--' + (type || 'primary'), className);
    var composeChildren = [];
    if (children) {
        composeChildren = composeChildren.concat(children);
    }
    return (react_1.default.createElement(utils_1.Report, __assign({}, otherProps, { className: css }),
        !!loading && react_1.default.createElement(spin_1.Spin, { className: "x-button__loading" }),
        composeChildren.map(function (children, index) {
            return (react_1.default.createElement("p", { className: "x-button__text", key: index }, children));
        })));
};
